#include <stdio.h>
#include <dlfcn.h>
#include <errno.h>
#include <sys/mman.h>

#include <string.h>

FILE 	*loader_logfile = NULL;

void loader_logs( char *str )
{
	if ( loader_logfile )
	{
		fputs( str, loader_logfile );
		fflush( loader_logfile );
	}
}

void loader_logi( unsigned i )
{
	if ( loader_logfile )
	{
		char	str[32];

		sprintf( str, "0x%08X", i );
		loader_logs( str );
	}
}

static void cacheflush(void *start, size_t size)
{
   /* For details, please see the Linux sources, files
    * arch/arm/kernel/traps.c, arch/arm/kernel/entry-common.S and
    * asm-arm/unistd.h
    *
    * This syscall is supported by all 2.4 and 2.6 Linux kernels.  2.2 linux
    * kernels got first support with version 2.2.18.
    */

   asm("mov r0, %0\n"
       "mov r1, %1\n"
       "mov r2, #0\n"
       /* EABI or Thumb syscall: syscall number passed in 'r7' (syscall base
	* number is 0x0).  Note that Thumb and EABI are generally not the
	* same.  It just happens that the simple cacheflush syscall doesn't
	* expose any of differences in calling conventions.
        */
       "mov r7, #0xf0000\n"
       "add r7, #0x02\n"
       "swi #0\n" ::
       "g"(start), "g"((long)start+size) :
       "r0", "r1", "r2", "r7");
}

void injector( const char *path )
{
	unsigned *handle=NULL;
	if ( (handle = dlopen(NULL,RTLD_LAZY | RTLD_GLOBAL)) == NULL )
	{
		loader_logs("Cannot open self!\n");
		loader_logs (dlerror());
		return;
	}

	unsigned *x1 = dlsym(handle,"_ZN14CViewerManager17ShowChannelBannerEbi");

	if ( x1 == NULL )
	{
		loader_logs("cannot find x1!\n");
		loader_logs(dlerror());
		loader_logs("\n");
		return;
	}

	dlclose(handle);

	int i;

	for( i = 0x40; i < 0x80; i++ )
	{
		if ( x1[i] == 0xE3570000 )
		{
			int page;

			page = ((unsigned) x1) & ~0x0FFF;
			mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);

			x1[i] = 0xE35700FF;

			mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);
			cacheflush(x1+i, 4);
			break;
		}
	}
}

int Game_Main(const char  *path, const char *udn __attribute__ ((unused)))
{
	char szlogfile[256];

	strcpy( szlogfile, path );
	strcat( szlogfile, "loader.log" );
	
//	remove( szlogfile );
	
//	loader_logfile = fopen( szlogfile,"a+" );
	
	injector( path );

	if ( loader_logfile ) fclose( loader_logfile );

	return 1;
}
